# -*- coding: utf-8 -*-

# *** THIS CLASS IS PUBLIC DOMAIN ***
# Made by John Eriksson in 2009
# http://arainyday.se

import pygame
import os.path, sys, random
from pygame.locals import *
from lib.loader import Loader

from lib.PaintBrush import PaintBrush
                       
class AdvancedDemo(object):
    def __init__(self):
        self.screen = pygame.display.set_mode((800,600),1)
        
        pygame.display.set_caption("Ζωγραφίζω")
        
        self.loader = Loader()
        
        self.simple_pal = self.loader.load_image("simple.png",False)
        self.advanced_pal = self.loader.load_image("advanced.png",False)
        self.simple = True
        
        self.back = self.loader.load_image("customback.png", False)
        #self.help = self.loader.load_image("help.png", True)
                        
        self.b1 = self.loader.load_image("brush_1.png", True) 
        self.b2 = self.loader.load_image("brush_2.png", True) 
        self.b3 = self.loader.load_image("brush_3.png", True) 
        self.b4 = self.loader.load_image("brush_4.png", True) 
        self.b5 = self.loader.load_image("brush_5.png", True) 
        self.b6 = self.loader.load_image("brush_6.png", True) 
        self.b7 = self.loader.load_image("brush_7.png", True)
        self.b8 = self.loader.load_image("brush_8.png", True)
        self.b9 = self.loader.load_image("brush_9.png", True)
        self.numbers = self.loader.load_image("numbers1.png", True)
        self.numbers.convert_alpha()
        
        self.cur_color = pygame.Color(0,0,0)
        self.paper_rect = pygame.Rect(3,106,794,492)
        self.paper = (pygame.Surface(self.paper_rect.size,1)).convert()
        self.templates=self.create_template()
        self.paper.fill((255,255,255))
        self.painting = False
        self.undo_cache = []
        
        self.pal_rect = pygame.Rect(146,4,300,102)
        
        self.newimage_rect = pygame.Rect(12,13,65,81)
        self.brush_rect = pygame.Rect(449,4,350,100)
        self.brush_rects = [] 
        self.brush_rects.append(pygame.Rect(449,4,101,200))
        self.brush_rects.append(pygame.Rect(549,53,50,50))
        self.brush_rects.append(pygame.Rect(549,4,50,50))
        self.brush_rects.append(pygame.Rect(601,53,50,50))
        self.brush_rects.append(pygame.Rect(601,4,50,50))
        self.brush_rects.append(pygame.Rect(651,53,50,50))
        self.brush_rects.append(pygame.Rect(651,4,50,50))
        self.brush_rects.append(pygame.Rect(701,53,50,50))
        self.brush_rects.append(pygame.Rect(701,4,50,50))
        self.brush_rects.append(pygame.Rect(751,53,50,50))
        self.brush_rects.append(pygame.Rect(751,4,50,50))    
        self.brush = PaintBrush(self.paper)        
        self.set_brush(2)

    def set_template(self,idx):
        if idx != 16:
            s="fonto%02d.png" % (idx)
            self.colouring = self.loader.load_image(s, False)
            self.colouring.set_colorkey(self.colouring.get_at((0,0)))
            self.colouring.convert()
            #print "We have a new template: {0}".format(s)
        
    def create_template(self):
        templates = pygame.Surface((720,540)).convert()
        self.template_rect = pygame.Rect(0,0,720,540)
        templates.fill((255,255,255))
        g=0
        self.template_rects = [] 
        for i in range(0,4):
            for n in range(0,4):
               g=g+1
               if g != 16:
                   s="fonto%02d.png" % (g)
                   t = self.loader.load_image(s, True).convert()
                   ts=pygame.transform.smoothscale(t,(140,100))
                   pygame.draw.rect(ts,(0,0,0),(0,0,140,100),1)
                   self.template_rects.append(pygame.Rect(80+i*160,80+n*120,140,100))
                   templates.blit(ts,(40+i*160,40+n*120))
               else:
                   t=pygame.Surface((140,100)).convert()
                   t.fill((255,255,255))
                   pygame.draw.rect(t,(0,0,0),(0,0,140,100),1)
                   self.template_rects.append(pygame.Rect(40+3*160,40+3*120,140,100))
                   templates.blit(t,(40+3*160,40+3*120))
        pygame.draw.rect(templates,(0,0,0),(0,0,720,540),2) 
        return templates

    def save_paper(self):
        self.undo_cache.append(self.paper.copy())
        self.undo_cache = self.undo_cache[-30:]

    def undo_paper(self):
        if len(self.undo_cache):
            p = self.undo_cache.pop()
            self.paper.blit(p,(0,0))

    def set_color(self,c):
        self.cur_color = c
        self.brush.set_color(c)
        
    def set_alpha(self,a):
        if a <= 0.0:
            a = 0.005
            x = 14
        elif a >= 1.0:
            a = 1.0
            x = 97
        else:
            x = int(round(14.0+83.0*a))
        self.brush.set_alpha(a)

    def set_brush(self,idx):
        if idx == 0:
            self.brush.set_brush(self.b1)
            self.brush.set_space(5.0)
            self.brush.set_color(self.cur_color)
            self.set_alpha(1.0)
        elif idx == 1:
            self.brush.set_brush(self.b2)
            self.brush.set_space(2.0)
            self.brush.set_color(self.cur_color)
            self.set_alpha(1.0)
        elif idx == 2:
            self.brush.set_brush(self.b3)
            self.brush.set_space(1.0)
            self.brush.set_color(self.cur_color)
            self.set_alpha(1.0)
        elif idx == 3:
            self.brush.set_brush(self.b4)
            self.brush.set_space(1.0)
            self.brush.set_color(self.cur_color)
            self.set_alpha(1.0)
        elif idx == 4:
            self.brush.set_brush(self.b5)
            self.brush.set_space(1.0)
            self.brush.set_color(self.cur_color)
            self.set_alpha(0.06)
        elif idx == 5:
            self.brush.set_brush(self.b6)
            self.brush.set_space(1.0)
            self.brush.set_color(self.cur_color)
            self.set_alpha(0.2)
        elif idx == 6:
            self.brush.set_brush(self.b6)
            self.brush.set_space(1.0)
            self.brush.set_color(self.cur_color)
            self.brush.set_follow_angle(True)
            self.set_alpha(0.2)
        elif idx == 7:
            self.brush.set_brush(self.b7)
            self.brush.set_space(1.0)
            self.brush.set_color(self.cur_color)
            self.set_alpha(0.15)
        elif idx == 8:
            self.brush.set_brush(self.b3)
            self.brush.set_space(1.0)
            self.brush.set_color(self.cur_color)
            self.brush.set_pattern([30,20,8,20])
            self.set_alpha(1.0)
        elif idx == 9:
            self.brush.set_brush(self.b8,True)
            self.brush.set_space(65.0)
            self.set_alpha(1.0)
        elif idx == 10:            
            self.brush.set_brush(self.b9,True)
            self.brush.set_space(20.0)
            self.brush.set_follow_angle(True)
            self.set_alpha(1.0)
        
    def paint_start(self):
        self.painting = True
        self.save_paper()
        
    def paint_stop(self):
        self.painting = False
    
    def swap_palette(self):
        self.simple = not self.simple
        if self.simple:
            self.back.blit(self.simple_pal, (12,12))
        else:
            self.back.blit(self.advanced_pal,(12,12))

    def draw_num(self,number):
        self.paint_start()
        x, y = pygame.mouse.get_pos()
        numsurf=pygame.surface.Surface((200,220))
        numsurf.fill((255,255,255))
        numsurf.blit(self.numbers,(0,0),(37*random.randint(0,3),number*78,37,78))
        #numsurf.convert_alpha()
        numsurf.convert()
        numzoom=pygame.transform.rotozoom(numsurf, random.randint(-10,10), random.uniform(0.5,2.5))
        numzoom.set_colorkey(numzoom.get_at((0,0)))
        numzoom.convert()
        numsurf.fill((255,255,255))
        numsurf.blit(numzoom,(0,0))
        numsurf.set_colorkey((255,255,255))
        numsurf.convert_alpha()
        self.paper.blit(numsurf, (x,y-self.paper_rect.top))
        
        #self.paper.blit(self.numbers, (x,y-self.paper_rect.top), (number*70,0,79,64))
        
        self.paint_stop()
        global sound_dir
        if number == 1:
            sound_path=os.path.join(sound_dir,"1.wav")
        elif number == 2:
            sound_path=os.path.join(sound_dir,"2.wav")
        elif number == 3:
            sound_path=os.path.join(sound_dir,"3.wav")
        elif number == 4:
            sound_path=os.path.join(sound_dir,"4.wav")
        elif number == 5:
            sound_path=os.path.join(sound_dir,"5.wav")
        elif number == 6:
            sound_path=os.path.join(sound_dir,"6.wav")
        elif number == 7:
            sound_path=os.path.join(sound_dir,"7.wav")
        elif number == 8:
            sound_path=os.path.join(sound_dir,"8.wav")
        elif number == 9:
            sound_path=os.path.join(sound_dir,"9.wav")
        elif number == 0:
            sound_path=os.path.join(sound_dir,"0.wav")    
        sound = pygame.mixer.Sound(sound_path)
        channel = sound.play()

    def main_loop(self):            
        clock = pygame.time.Clock()
        
        line_from = None
        line_to = None

        cur_color = pygame.Color(0,0,0)

        next_update = pygame.time.get_ticks()
        fullscreen_mode = False
        view_template = True
        enabled_template = 16
        
        while 1:            
            for event in pygame.event.get():                
                if view_template:
                    if event.type == QUIT:
                        return
                    elif event.type == KEYDOWN:
                        if event.key == K_ESCAPE:
                            return                    
                        else:
                            view_template = False
                    elif event.type == MOUSEBUTTONDOWN:
                        if event.button == 1:                            
                            if self.template_rect.collidepoint(event.pos):
                                i = 1
                                for r in self.template_rects:
                                    if r.collidepoint(event.pos):
                                        self.set_template(i)
                                        enabled_template = i
                                        view_template=False
                                        self.paint_start()
                                        self.paper.fill((255,255,255))
                                        self.paint_stop()
                                    i+=1                                                
                                
                else:
                    if event.type == QUIT:
                        return
                    elif event.type == KEYDOWN:
                        if event.key == K_ESCAPE:
                            return                    
                        elif event.key == K_SPACE:
                            self.paint_start()
                            self.paper.fill((255,255,255))
                            self.paint_stop()    
                        elif event.key == K_F1:
                            view_template = True
                        elif event.key == K_F2:
                            pass
                            #self.swap_palette()
                        elif event.key == K_F4:
                            fullscreen_mode = not fullscreen_mode
                            if fullscreen_mode:
                                self.screen = pygame.display.set_mode((800,600),FULLSCREEN)
                            else:
                                self.screen = pygame.display.set_mode((800,600),1)
                        elif event.key == K_0:
                            self.draw_num(0)
                        elif event.key == K_1:
                            self.draw_num(1)
                        elif event.key == K_2:
                            self.draw_num(2)
                        elif event.key == K_3:
                            self.draw_num(3)
                        elif event.key == K_4:
                            self.draw_num(4)
                        elif event.key == K_5:
                            self.draw_num(5)
                        elif event.key == K_6:
                            self.draw_num(6)
                        elif event.key == K_7:
                            self.draw_num(7)
                        elif event.key == K_8:
                            self.draw_num(8)
                        elif event.key == K_9:
                            self.draw_num(9)
                        elif event.key == 122 and event.mod == 64:
                            self.undo_paper()
                    
                    elif event.type == MOUSEBUTTONDOWN:
                        if event.button == 1:
                            if self.newimage_rect.collidepoint(event.pos):
                                view_template = True
                            if self.pal_rect.collidepoint(event.pos):
                                c = self.back.get_at(event.pos)
                                self.set_color(c)
                            elif self.brush_rect.collidepoint(event.pos):
                                i = 0
                                for r in self.brush_rects:
                                    if r.collidepoint(event.pos):
                                        self.set_brush(i)
                                    i+=1                            
                            elif self.paper_rect.collidepoint(event.pos):
                                self.paint_start()
                                x = event.pos[0]-self.paper_rect.x
                                y = event.pos[1]-self.paper_rect.y
                                self.brush.paint_from((x,y))
                        elif event.button == 3:
                            if self.paper_rect.collidepoint(event.pos):
                                line_from = event.pos
                            elif self.pal_rect.collidepoint(event.pos):
                                self.swap_palette()
                    elif event.type == MOUSEMOTION:
                        if event.buttons[0]:
                            if self.paper_rect.collidepoint(event.pos):
                                if self.painting:
                                    x = event.pos[0]-self.paper_rect.x
                                    y = event.pos[1]-self.paper_rect.y
                                    self.brush.paint_to((x,y))                            
                        elif event.buttons[2]:
                            if self.paper_rect.collidepoint(event.pos):
                                line_to = event.pos
                                painting = False                            
                    elif event.type == MOUSEBUTTONUP:
                        if event.button == 1 and self.painting:
                            self.paint_stop()
                        if event.button == 3:
                             if line_from:
                                self.paint_start()
                                fx = line_from[0]-self.paper_rect.x
                                fy = line_from[1]-self.paper_rect.y
                                tx = event.pos[0]-self.paper_rect.x
                                ty = event.pos[1]-self.paper_rect.y
                                self.brush.paint_line((fx,fy),(tx,ty))
                                self.paint_stop()
                                line_from = None
                                line_to = None
                                                          
            if pygame.time.get_ticks() >= next_update:
                next_update+=33
                self.screen.blit(self.back,(0,0))
                self.screen.blit(self.paper,self.paper_rect.topleft)
                if enabled_template != 16:              
                    colpos=((self.paper_rect.width-self.colouring.get_width())/2,self.paper_rect.top+(self.paper_rect.height-self.colouring.get_height())/2)
                    self.screen.blit(self.colouring,colpos)
                if not view_template:
                    if line_from and line_to:
                        pygame.draw.line(self.screen, (0,0,0), line_from, line_to)                
                if view_template:
                    self.screen.blit(self.templates,(40,40))
                    #for r in self.template_rects:
                    #    pygame.draw.rect(self.screen,(255,0,0),r,2)                
                pygame.display.flip()            

def main():
    try:
        import psyco
        psyco.full()
    except ImportError:
        pass

    pygame.init()

    g = AdvancedDemo()
    g.main_loop()
    pygame.quit()
if __name__ == '__main__':
    main_dir = os.path.realpath(os.path.dirname(sys.argv[0]))     
    sound_dir = os.path.join(main_dir,'data\snd')
    main()

